/**
* powered by HZ.
* Copyright Tnice.com All Rights Reserved.
*/

/* object object extend */
/* arguments to array */
Object.toArray = function (object) {
    for (var i = 0, length = object.length, array = []; i < length; i++) {
        array.push(object[i]);
    };
    return array;
};

/* string to object */
Object.jsonDecode = function (data) {
    return Function("return " + data + ";")();
};

/* number object extend  */
/* number to fixed */
Number.toFixed = function (number, length) {
    number = number.toString();
    var numberLength = number.length;
    if (numberLength < length) {
        var i = length - numberLength;
        while (i--) {
            number = "0" + number;
        };
    };
    return number;
};

/* string object extend  */
/* string to number int */
String.toInt = function (str) {
    return parseInt(str.replace(/\D+/g, ""), 10) || 0;
};

/* string left and right pad 0 */
String.padLeft = function (str, length) {
    str = str.toString();
    if (str.length < length) {
        return arguments.callee("0" + str, length);
    };
    return str;
};
String.padRight = function (str, length) {
    str = str.toString();
    if (str.length < length) {
        return arguments.callee(str + "0", length);
    };
    return str;
};

/* remove the whitespace from a string */
String.trim = function (str, position) {
    if (position === "beginning") return str.replace(/(^\s+)/g, "");
    if (position === "end") return str.replace(/(\s+$)/g, "");
    if (position === "all") return str.replace(/(\s+)/g, "");
    return str.replace(/(^\s+)|(\s+$)/g, "");
};

/* array object extend  */
/* item in array object return index */
Array.inArray = function (array, item) {
    for (var i = 0, length = array.length; i < length; i++) {
        if (item === array[i]) {
            return i;
        };
    };
    return -1;
};
/* clone array return new array */
Array.clone = function (array) {
    var _toString = Object.prototype.toString;
    for (var i = 0, newArray = [], length = array.length; i < length; i++) {
        if (_toString.call(array[i]) === "[object Array]") {
            newArray[i] = arguments.callee(array[i]);
        } else {
            newArray[i] = array[i];
        };
    };
    return newArray;
};

/* get string char count */
String.getCharCount = function (str) {
    str = String.trim(str);
    var sum = 0,
        regexp = /[\w\s+]/g,
        word = str.match(regexp);
    if (!!word) {
        sum = word.length;
        str = str.replace(regexp, "");
    };
    for (var i = 0, n = 0, length = str.length; i < length; i++) {
        n = str.charCodeAt(i);
        if (n >= 0 && n <= 255) {
            sum += 1;
        } else {
            sum += 2;
        };
    };
    return sum;
};

/* location object extend */
/* get url arguments and returns an object */
location.getArguments = function (scope) {
    scope = scope || window;
    var regExp = /([^?]+\?)/,
        href = scope.location.href,
        urlArguments = regExp.test(href),
        object = {};
    if (urlArguments) {
        urlArguments = unescape(scope.location.href.replace(regExp, ""));
        if (urlArguments) {
            urlArguments = urlArguments.split("&");
            var trimRegExp = /(^\s+)|(\s+$)/g,
                length = urlArguments.length,
                index = -1,
                i = 0,
                attribute,
                value,
                arg;
            for (; i < length; i++) {
                arg = urlArguments[i];
                index = arg.search("=");
                attribute = arg;
                if (index > -1) {
                    attribute = arg.substr(0, index);
                    value = arg.substr(index + 1).replace(trimRegExp, "");
                };
                attribute = attribute.replace(trimRegExp, "");
                if (!object[attribute]) {
                    object[attribute] = [];
                };
                object[attribute].push(value);
            };
        };
    };
    return object;
};

/* event object extend  */
var Event = function (object) {
    object.getKeyCode = function (e) {
        if (!e) {
            e = window.event;
        };
        return e.which || e.keyCode || false;
    };
    object.detectCapsLock = function (e) {
        if (!e) {
            e = window.event;
        };
        var keyCode = e.which || e.keyCode,
            isShift = e.shiftKey || (keyCode == 16) || false;
        if (((keyCode >= 65 && keyCode <= 90) && !isShift) || ((keyCode >= 97 && keyCode <= 122) && isShift)) {
            return true;
        };
        return false;
    };
    object.preventDefault = function (e) {
        if (!e) {
            e = window.event;
        };
        if (e.preventDefault) {
            e.preventDefault();
        } else {
            e.returnValue = false;
        };
    };
    object.stopPropagation = function (e) {
        if (!e) {
            e = window.event;
        };
        if (e.stopPropagation) {
            e.stopPropagation();
        } else {
            e.cancelBubble = true;
        };
    }
    return object;
} (Event || {});

/* scroll object extend */
var Scroll = function (object, window) {
    function extend(destination, source) {
        for (var property in source) {
            destination[property] = source[property];
        };
        return destination;
    };
    object.left = function (x) {
        if (!x) {
            return window.scrollX || document.documentElement.scrollLeft;
        };
        window.scrollTo(x, this.top);
    };
    object.top = function (y) {
        if (!y) {
            return window.scrollY || document.documentElement.scrollTop;
        };
        window.scrollTo(this.left, y);
    };
    object.scrollTo = function (x, y) {
        var left = Scroll.left(),
            top = Scroll.top();
        if (Object.prototype.toString.call(x) === "[object Object]") {
            var attributes = {
                x: 0,
                y: 0,
                speed: 0,
                millisec: 10,
                callback: function () { }
            };
            var options = extend(extend({}, attributes), x),
                x = options.x,
                y = options.y,
                speed = options.speed,
                millisec = options.millisec;
            if (x != left || y != top) {
                if (speed >= millisec) {
                    var frequency = Math.floor(speed / millisec),
                        i = 0,
                        _x = 0,
                        _y = 0;
                    if (x >= 0) {
                        _x = Math.floor((x - left) / frequency);
                    };
                    if (y >= 0) {
                        _y = Math.floor((y - top) / frequency);
                    };
                    var timer = setInterval(function () {
                        i++;
                        Scroll.scrollBy(_x, _y);
                        if (i >= frequency) {
                            clearInterval(timer);
                            Scroll.scrollTo(x, y);
                            options.callback();
                        };
                    }, millisec);
                } else {
                    window.scrollTo(x, y);
                };
            };
        } else if (x != left || y != top) {
            window.scrollTo(x, y);
        };
    };
    object.scrollBy = function (x, y) {
        window.scrollBy(x, y);
    };
    return object;
} (Scroll || {}, window);

/* document object extend  */
/* states if the current page, in the user's browser, is being rendered using the W3C CSS Box Model. */
document.boxModel = function () {
    var boxModel;
    return function () {
        if (typeof boxModel != "undefined") {
            return boxModel;
        } else {
            var d = document,
                body = document.body,
                div = d.createElement("div");
            document.body.insertBefore(div, body.firstChild);
            div.style.width = div.style.paddingLeft = "1px";
            boxModel = (div.offsetWidth === 2);
            body.removeChild(div);
            return boxModel;
        };
    };
} ();

/* document fragment object extend */
document.fragment = function (elements) {
    var fragment = document.createDocumentFragment();
    for (var i = 0, length = elements.length; i < length; i++) {
        fragment.appendChild(elements[i]);
    };
    return fragment;
};

/* check the element is an contains element */
if (typeof (HTMLElement) != "undefined") {
    HTMLElement.prototype.contains = function (element) {
        while (!!(element && element.nodeType == 1)) {
            if (element == this) {
                return true;
            };
            element = element.parentNode;
        };
        return false;
    };
};

/* input object extend */
var input = function () {
    /* selected the input text */
    var selectedText = function (element) {
        if (element.setSelectionRange) {
            element.setSelectionRange(0, element.value.length);
        } else if (element.createTextRange) {
            element.createTextRange().select();
        };
        return element;
    };
    /* check the input text format */
    var check = function () {
        function isEmail(str) {
            return /^([a-zA-Z0-9]+([._-][a-zA-Z0-9])*)+@([a-zA-Z0-9]+([_-][a-zA-Z0-9])*\.)+(([a-zA-Z0-9]{2,3}[a-zA-Z0-9]?[a-zA-Z0-9]?){1})$/.test(str);
        };
        function isNumber(str) {
            return !/\D/.test(str) && str != "";
        };
        function isMobileNumber(str) {
//            return /^1[3,5,8,4]\d{9}$/.test(str);
            return str.length == 11 && /\d{11}/.test(str);
        };
        function isPhoneNumber(str) {
//            return str.length <= 19 && /(^(\d{3,4}\-?\d{7,8}|\d{7,8})-?\d*$)/.test(str);
            return str.length >= 3 && /\d{3,}/.test(str);
        };
        function isMobileAuthCode(str) {
            return /\d{6}/.test(str);
        };
        function isChineseCharacter(str) {
            return /[\u4e00-\u9fa5]/.test(str);
        };
        function isDoubleCharacter(str) {
            return /[^\x00-\xff]/.test(str);
        };
        function isBlankline(str) {
            return /\n\s*\r/.test(str);
        };
        function isUrl(str) {
            return /[a-zA-z]+\:\/\/[^\s]*/.test(str);
        };
        function isQQNumber(str) {
            return /[1-9][0-9]{4,}/.test(str);
        };
        function isPostcode(str) {
            return str.length == 6 && /[1-9]{1}\d{5}/.test(str);
        };
        function isIdentityNumber(str) {
            return str.length == 18 && /\d{17}[0-9xX]{1}/.test(str);
        };
        function isIpAddress(str) {
            return /\d+.\d+.\d+.\d+/.test(str);
        };
        function isBirthday(str) {
            return str.length == 8 && /\d{4}[01][0-9][0-3][0-9]/.test(str);
        };
        function isPassword(str) {
            return !(str.length < 6 || str.length > 18 || /[^a-zA-Z0-9_\-.?]/.test(str));
        };
        return {
            isEmail: isEmail,
            isNumber: isNumber,
            isMobileNumber: isMobileNumber,
            isPhoneNumber: isPhoneNumber,
            isMobileAuthCode: isMobileAuthCode,
            isChineseCharacter: isChineseCharacter,
            isDoubleCharacter: isDoubleCharacter,
            isBlankline: isBlankline,
            isUrl: isUrl,
            isQQNumber: isQQNumber,
            isPostcode: isPostcode,
            isIdentityNumber: isIdentityNumber,
            isIpAddress: isIpAddress,
            isBirthday: isBirthday,
            isPassword: isPassword
        };
    } ();
    /* format the input text */
    var format = function () {
        var toInt = function (str) {
            return str.replace(/\D+/g, "");
        };
        var toFloat = function (str) {
            str = str.replace(/[^0-9.]+/g, "");
            if (/[.]\d*[.]/.test(str)) {
                return parseFloat(str);
            };
            return str;
        };
        return {
            toInt: toInt,
            toFloat: toFloat,
            toNumber: toFloat
        };
    } ();
    return {
        check: check,
        format: format,
        selectedText: selectedText
    }
} ();

/* time object extend */
var time = function () {
    var countDown = function (time) {
        time = time || "99:59:59";
        var timer = null,
            timeArray = time.split(":").reverse();
        function start() {
            clearTimeout(timer);
            if (parseInt(timeArray.join(""), 10) > 0) {
                timer = setTimeout(arguments.callee, 1000);
                trim(timeArray, 0);
            };
        };
        function stop() {
            clearTimeout(timer);
        };
        function trim(array, length) {
            var n = parseInt(array[length], 10) - 1;
            if (n < 0) {
                if (length >= array.length) {
                    clearTimeout(timer);
                    return false;
                };
                if (!arguments.callee(array, length + 1)) {
                    return false;
                };
                n = 59;
            };
            n = n.toString();
            if (n.length < 2) {
                n = "0" + n;
            };
            array[length] = n;
            return true;
        };
        function getHours() {
            return timeArray[2];
        };
        function getMinutes() {
            return timeArray[1];
        };
        function getSeconds() {
            return timeArray[0];
        };
        function getTime() {
            return timeArray;
        };
        function setHours(hour) {
            stop();
            timeArray[2] = hour;
            start();
            return timeArray;
        };
        function setMinutes(minute) {
            stop();
            timeArray[1] = minute;
            start();
            return timeArray;
        };
        function setSeconds(second) {
            stop();
            timeArray[0] = second;
            start();
            return timeArray;
        };
        function setTime(time) {
            stop();
            timeArray = time.split(":").reverse();
            start();
            return timeArray;
        };
        return {
            stop: stop,
            start: start,
            getHours: getHours,
            getMinutes: getMinutes,
            getSeconds: getSeconds,
            getTime: getTime,
            setHours: setHours,
            setMinutes: setMinutes,
            setSeconds: setSeconds,
            setTime: setTime
        };
    };
    var conversion = function () {
        var hour = function () {
            function toDay(hours) {
                return [Math.floor(hours / 24), hours % 24];
            };
            return {
                toDay: toDay
            };
        } ();
        return {
            hour: hour
        };
    } ();
    return {
        countDown: countDown,
        conversion: conversion
    };
} ();

/* test function supports */
var supports = function (window) {
    var mod = "hz";
    var webWorkers = function () {
        return !!window.Worker;
    };
    var applicationCache = function () {
        return !!window.applicationCache;
    };
    var webSqlDatabase = function () {
        return !!window.openDatabase;
    };
    var localStorage = function () {
        try {
            window.localStorage.setItem(mod, mod);
            window.localStorage.removeItem(mod);
            return true;
        } catch (e) {
            return false;
        };
    };
    var sessionStorage = function () {
        try {
            window.sessionStorage.setItem(mod, mod);
            window.sessionStorage.removeItem(mod);
            return true;
        } catch (e) {
            return false;
        };
    };
    return {
        webWorkers: webWorkers,
        applicationCache: applicationCache,
        webSqlDatabase: webSqlDatabase,
        localStorage: localStorage,
        sessionStorage: sessionStorage
    };
} (window);

/* add to addBookmark */
function addBookmark(url, title) {
    var w = window,
        d = document,
        url = url || location.href,
        title = title || document.title;
    if (d.all && w.external) {
        w.external.AddFavorite(url, title);
    } else if (w.sidebar) {
        w.sidebar.addPanel(title, url, "");
    } else {
        alert("您的浏览器不支持此操作，请按 “Ctrl+D” 手动添加。");
    };
};

/* set homepage */
function setHomepage(url) {
    var w = window,
        d = document,
        b = d.body,
        url = url || location.href;
    if (d.all) {
        b.style.behavior = "url(#default#homepage)";
        b.setHomePage(url);
    } else if (w.sidebar) {
        if (w.netscape) {
            try {
                netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
            } catch (e) {
                return alert("该操作被浏览器拒绝，如果想启用该功能，请在地址栏内输入 about:config,然后将项 signed.applets.codebase_principal_support 值该为true");
            };
        };
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        prefs.setCharPref("browser.startup.homepage", url);
    } else {
        alert("您的浏览器不支持此操作，请手动设置。");
    };
};