/*
* jquery.dialogbox
* @author hz
* blog: www.joyfulboy.cn
* mail: beijingren<beijingren at vip.qq.com>
* @copyright (c) 2012 www.tnice.com
*/

(function ($) {
    $.fn.dialogbox = function () {
        var win = window,
            doc = document,
            body = doc.body,
            awin = $(win),
            adoc = $(doc),
            abody = $(body),
            browser = $.browser,
            zIndex = 99,
            ie6 = browser.msie && browser.version == '6.0',
            iframe = $('<iframe src="about:blank" data-id="dialogboxIframe" style="border: 0; background-color: #000; overflow: hidden; position: absolute; left: 0; top: 0; z-index: ' + zIndex + '; filter: alpha(opacity=0); display: none;"></iframe>'),
            dialogboxIframe = $('iframe[data-id=dialogboxIframe]')[0];
        var settings = {
            mask: false,
            maskOpacity: 0.5
        };
        if (ie6 && !dialogboxIframe) {
            abody.prepend(iframe);
        };
        return function (options) {
            options = $.extend($.extend({}, settings), options);
            var that = this,
                elements = $(that),
                onReady = options.onReady,
                ok = options.ok,
                cancel = options.cancel,
                okElements = $('.dialogbox-action .ok', elements),
                cancelElements = $('.dialogbox-action .cancel', elements);
            function _show() {
                var onShowBefore = options.onShowBefore;
                if (onShowBefore) {
                    onShowBefore.apply(that);
                };
                var that = $(this),
                    o = options,
                    width = o.width,
                    height = o.height,
                    left = o.left,
                    top = o.top,
                    onShow = o.onShow,
                    docWidth = adoc.width(),
                    docHeight = adoc.height(),
                    winHeight = awin.height(),
                    bg = $('div[data-dialogbox-bg-id=' + that.attr('data-id') + ']').eq(0);
                if (o.mask) {
                    if (ie6 && !iframe.attr('data-dialogbox-iframe-status')) {
                        iframe.css({
                            'width': docWidth,
                            'height': docHeight
                        });
                        iframe.attr('data-dialogbox-iframe-status', '1');
                        iframe.show();
                    };
                    if (bg[0]) {
                        bg.show();
                    } else {
                        bg = $('<div data-dialogbox-bg-id="' + that.attr('data-id') + '" style="background-color: #000; position: absolute; left: 0; top: 0; opacity: ' + o.maskOpacity + '; filter: alpha(opacity=' + o.maskOpacity * 100 + '); z-index: ' + ++zIndex + '; width: ' + docWidth + 'px; height: ' + docHeight + 'px;"></div>');
                        abody.prepend(bg);
                    };
                };
                that.css({
                    'width': width ? width + 'px' : 'auto',
                    'height': height ? height + 'px' : 'auto',
                    'left': (left || (docWidth - that.width()) / 2) + 'px',
                    'top': (top || (winHeight - that.height()) / 2 + awin.scrollTop()) + 'px',
                    'z-index': ++zIndex
                });
                that.attr('data-dialogbox-status', '1');
                that.show();
                if (onShow) {
                    onShow.apply(this);
                };
            };
            function _hide() {
                var onHideBefore = options.onHideBefore;
                if (onHideBefore) {
                    onHideBefore.apply(that);
                };
                var that = $(this),
                    o = options,
                    onHide = o.onHide;
                that.hide();
                that.removeAttr('data-dialogbox-status');
                if (o.mask) {
                    $('div[data-dialogbox-bg-id=' + that.attr('data-id') + ']').hide();
                    if (ie6 && !$('div[data-dialogbox-status = 1]').eq(0)[0]) {
                        iframe.removeAttr('data-dialogbox-iframe-status');
                        iframe.hide();
                    };
                };
                if (onHide) {
                    onHide.apply(this);
                };
            };
            function show() {
                var onShowBefore = options.onShowBefore;
                if (onShowBefore) {
                    onShowBefore.apply(that);
                };
                _show.apply(elements);
                return elements;
            };
            function hide() {
                var onHideBefore = options.onHideBefore;
                if (onHideBefore) {
                    onHideBefore.apply(that);
                };
                _hide.apply(elements);
                return elements;
            };
            elements.bind({
                dshow: show,
                dhide: hide
            });
            elements.dshow = show;
            elements.dhide = hide;
            $('.dialogbox-close', elements).bind('click', hide);
            if (ok && okElements[0]) {
                if (ok) {
                    okElements.bind('click', function () {
                        ok.apply(that);
                    });
                } else {
                    okElements.bind('click', hide);
                };
            };
            if (cancelElements[0]) {
                if (cancel) {
                    cancelElements.bind('click', function () {
                        cancel.apply(that);
                    });
                } else {
                    cancelElements.bind('click', hide);
                };
            };
            if (onReady) {
                onReady.apply(that);
            };
            return elements;
        };
    } ();
})($);
