/*
* jquery.document.phonyLabel
* @author hz
* blog: www.joyfulboy.cn
* mail: beijingren<beijingren at vip.qq.com>
* @copyright (c) 2012 www.tnice.com
*/

jQuery.document = function (object) {
    object.phonyLabel = function (phony, input) {
        var browser = $.browser,
            $window = $(window),
            oninput = function () {
                if (this.value) {
                    var parent = $(this.parentNode);
                    if (!parent.filter(".phony-hide")[0]) {
                        parent.addClass("phony-hide");
                    };
                };
            };
        input.bind({
            "focus": function () {
                var parent = $(this.parentNode);
                if (!parent.filter(".phony-focus")[0]) {
                    parent.addClass("phony-focus");
                };
            },
            "blur": function () {
                if (!this.value) {
                    $(this.parentNode).removeClass("phony-focus phony-hide");
                };
            }
        });
        phony.bind("click", function () {
            input.focus();
        });
        if (browser.msie && parseFloat(browser.version) < "9") {
            input[0].attachEvent("onpropertychange", function (event) {
                if (event.propertyName == "value") {
                    oninput.call(event.srcElement, event);
                };
            });
            $window.one("load", function () {
                var value = input.val();
                if (value.length > 0) {
                    input.val(value);
                };
            });
            $window.trigger("load");
        } else {
            input.bind("input", oninput);
            $window.one("load", function () {
                if (input.val().length > 0) {
                    input.trigger("input");
                };
            });
            $window.trigger("load");
        };
    };
    return object;
} (jQuery.document || {});