/*
* jquery.message
* @author hz
* blog: www.joyfulboy.cn
* mail: beijingren<beijingren at vip.qq.com>
* @copyright (c) 2012 www.tnice.com
*/

jQuery.message = function (object) {
    object.element = function () {
        function create(type, msg) {
            if (type == "warning") {
                return $('<p class="warning" data-message-type="warning" data-find-name="message"><span>' + msg + '</span></p>');
            };
            if (type == "error") {
                return $('<p class="error" data-message-type="error" data-find-name="message"><span>' + msg + '</span></p>');
            };
            if (type == "ok") {
                return $('<p class="ok" data-message-type="ok" data-find-name="message"><span>' + msg + '</span></p>');
            };
            if (type == "loading") {
                return $('<p class="loading" data-message-type="loading" data-find-name="message"><span>' + msg + '</span></p>');
            };
            if (type == "sub-error") {
                return $('<p class="sub-error" data-message-type="sub-error" data-find-name="message"><span>' + msg + '</span></p>');
            };
        };
        function show(type, msg, parent, append) {
            var element = parent.find("[data-find-name='message'][data-message-type='" + type + "']");
            append = append || "append";
            if (element[0]) {
                element.find("span").eq(0).html(msg);
                element.show();
            } else {
                parent[append](create(type, msg));
            };
            return parent;
        };
        function hide(type, parent) {
            find(type, parent).hide();
            return parent;
        };
        function find(type, parent) {
            if (Object.prototype.toString.call(type) === "[object String]") {
                return parent.find("[data-find-name='message'][data-message-type='" + type + "']");
            };
            return type.find("[data-find-name='message']");
        };
        return {
            create: create,
            show: show,
            hide: hide,
            find: find
        };
    } ();
    return object;
} (jQuery.message || {});