/*
* jquery.message
* @author hz
* blog: www.joyfulboy.cn
* mail: beijingren<beijingren at vip.qq.com>
* @copyright (c) 2012 www.tnice.com
*/

jQuery.message = function (object) {
    object.element = function () {
        function create(type, msg) {
            if (type == "warning") {
                return $('<span class="message warning" data-message-type="warning" data-find-name="message-warning"><i>' + msg + '</i></span>');
            };
            if (type == "error") {
                return $('<span class="message error" data-message-type="error" data-find-name="message-error"><i>' + msg + '</i></span>');
            };
            if (type == "ok") {
                return $('<span class="message ok" data-message-type="ok" data-find-name="message-ok"><i>' + msg + '</i></span>');
            };
            if (type == "loading") {
                return $('<span class="message loading" data-message-type="loading" data-find-name="message-loading"><i>' + msg + '</i></span>');
            };
        };
        function show(type, msg, parent, append) {
            var element = parent.find("[data-message-type=" + type + "]");
            append = append || "append";
            if (element[0]) {
                element.find("i").eq(0).html(msg);
                element.show();
            } else {
                parent[append](create(type, msg));
            };
            return parent;
        };
        function hide(type, parent) {
            find(type, parent).hide();
            return parent;
        };
        function find(type, parent) {
            return parent.find("[data-message-type=" + type + "]");
        };
        return {
            create: create,
            show: show,
            hide: hide,
            find: find
        };
    } ();
    return object;
} (jQuery.message || {});