/**
* option
* @version 1.0.0
* @author hz
* blog: www.joyfulboy.cn
* mail: beijingren<beijingren at vip.qq.com>
* @copyright (c) 2012 www.joyfulboy.cn
*/

var option = function () {
    var attributes = {
        whole: true,
        data: [],
        word: ""
    };
    var extend = function (destination, source) {
        for (var property in source) {
            destination[property] = source[property];
        };
        return destination;
    };
    var trim = function (str) {
        return str.replace(/(^\s+)|(\s+$)/g, "");
    };
    var filter = function (obj) {
        obj = extend(extend({}, attributes), obj);
        var whole = obj.whole,
            data = obj.data,
            word = trim(obj.word),
            array = [];
        if (word) {
            if (whole) {
                for (var i = 0, length = data.length, item = null; i < length; i++) {
                    item = data[i];
                    if (item.name.toLowerCase().search(word.toLowerCase()) === 0) {
                        array.push(item);
                    };
                };
            } else {
                for (var i = 0, length = data.length, item = null; i < length; i++) {
                    item = data[i];
                    if (item.name.toLowerCase().search(word.toLowerCase()) >= 0) {
                        array.push(item);
                    };
                };
            };
        };
        return array;
    };
    return {
        filter: filter
    };
} ();